;;;
;;; sxml.to-html - SXML->HTML translator
;;;
;;;   This file is mechanically translated for Gauche from
;;;   Oleg Kiselyov's SXML->HTML.scm.
;;;   Public domain.
;;;
;;; $Id: to-html.scm.in,v 1.2 2002/02/15 08:48:52 shirok Exp $
;;;

(define-module sxml.to-html
  (use text.parse)
  (use text.html-lite)
  (use sxml.adaptor)
  (use sxml.tree-trans)
  (export SXML->HTML))
(select-module sxml.to-html)

;; Hack: a procedure "make-char-quotator" is used in the original code
;; to generate a procedure that does escaping for HTML.   Since it is
;; used only for that purpose, we can just replace it to what we have
;; in text.html-lite module.
(define (make-char-quotator . _) html-escape-string)

;;; Generated from Oleg Kiselyov's "SXML-to-HTML.scm"



(define-macro (run-test . body) '(begin #f))
(define (SXML->HTML tree) (SRV:send-reply (post-order tree `((|@| ((*default* unquote (lambda (attr-key . value) ((enattr attr-key) value)))) unquote (lambda (trigger . value) (list '|@| value))) (*default* unquote (lambda (tag . elems) (apply (entag tag) elems))) (*text* unquote (lambda (trigger str) (if (string? str) (string->goodHTML str) str))) (html:begin unquote (lambda (tag title . elems) (assert (string? title)) (list "Content-type: text/html" "\n\n" "<HTML><HEAD><TITLE>" title "</TITLE></HEAD>\n" elems "</HTML>")))))))
(define (entag tag) (lambda elems (if (and (pair? elems) (pair? (car elems)) (eq? '|@| (caar elems))) (list #\< tag (cdar elems) #\> (and (pair? (cdr elems)) (list (cdr elems) "</" tag #\>)) #\newline) (list #\< tag #\> (and (pair? elems) (list elems "</" tag #\>)) #\newline))))
(define (enattr attr-key) (lambda (value) (if (null? value) (list #\space attr-key) (list #\space attr-key "=\"" value #\"))))
(define string->goodHTML (make-char-quotator '((#\< . "&lt;") (#\> . "&gt;") (#\& . "&amp;") (#\" . "&quot;"))))


(provide "sxml/to-html")

;; Local variables:
;; mode: scheme
;; end:
