;;;
;;; sxml.tree-trans - SXML utility
;;;
;;;   This file is mechanically translated for Gauche from
;;;   Oleg Kiselyov's SXML-tree-trans.scm, v 1.5.
;;;   Public domain.
;;;
;;; $Id: tree-trans.scm.in,v 1.2 2002/02/15 08:53:10 shirok Exp $
;;;

(define-module sxml.tree-trans
  (use text.parse)
  (use sxml.adaptor)
  (export SRV:send-reply
          post-order
          pre-post-order
          foldts
          replace-range))
(select-module sxml.tree-trans)

;;; Generated from Oleg Kiselyov's "SXML-tree-trans.scm"
(define-macro (run-test . body) '(begin #f))
(define (SRV:send-reply . fragments) (let loop ((fragments fragments) (result #f)) (cond ((null? fragments) result) ((not (car fragments)) (loop (cdr fragments) result)) ((null? (car fragments)) (loop (cdr fragments) result)) ((pair? (car fragments)) (loop (cdr fragments) (loop (car fragments) result))) ((procedure? (car fragments)) ((car fragments)) (loop (cdr fragments) #t)) (else (display (car fragments)) (loop (cdr fragments) #t)))))
(define (nodeset? x) (or (and (pair? x) (not (symbol? (car x)))) (null? x)))
(define (map-union proc lst) (if (null? lst) lst (let ((proc-res (proc (car lst)))) ((if (nodeset? proc-res) append cons) proc-res (map-union proc (cdr lst))))))
(define (post-order tree bindings) (cond ((nodeset? tree) (map (lambda (a-tree) (post-order a-tree bindings)) tree)) ((not (pair? tree)) (let ((trigger '*text*)) (cond ((or (assq trigger bindings) (assq '*default* bindings)) => (lambda (binding) ((if (procedure? (cdr binding)) (cdr binding) (cddr binding)) trigger tree))) (else (error "Unknown binding for " trigger " and no default"))))) (else (let ((trigger (car tree))) (cond ((or (assq trigger bindings) (assq '*default* bindings)) => (lambda (binding) (apply (if (procedure? (cdr binding)) (cdr binding) (cddr binding)) (cons trigger (post-order (cdr tree) (if (pair? (cdr binding)) (append (cadr binding) bindings) bindings)))))) (else (error "Unknown binding for " trigger " and no default")))))))
(define (pre-post-order tree bindings) (cond ((nodeset? tree) (map (lambda (a-tree) (pre-post-order a-tree bindings)) tree)) ((not (pair? tree)) (let ((trigger '*text*)) (cond ((or (assq trigger bindings) (assq '*default* bindings)) => (lambda (binding) ((if (procedure? (cdr binding)) (cdr binding) (cddr binding)) trigger tree))) (else (error "Unknown binding for " trigger " and no default"))))) (else (let ((trigger (car tree))) (cond ((or (assq trigger bindings) (assq '*default* bindings)) => (lambda (binding) (if (and (pair? (cdr binding)) (eq? '*preorder* (cadr binding))) (apply (cddr binding) tree) (apply (if (procedure? (cdr binding)) (cdr binding) (cddr binding)) (cons trigger (pre-post-order (cdr tree) (if (pair? (cdr binding)) (append (cadr binding) bindings) bindings))))))) (else (error "Unknown binding for " trigger " and no default")))))))
(define (foldts fdown fup fhere seed tree) (cond ((null? tree) seed) ((not (pair? tree)) (fhere seed tree)) (else (let loop ((kid-seed (fdown seed tree)) (kids (cdr tree))) (if (null? kids) (fup seed kid-seed tree) (loop (foldts fdown fup fhere kid-seed (car kids)) (cdr kids)))))))
(define (replace-range beg-pred end-pred forest) (define (loop forest keep? new-forest) (if (null? forest) (values (reverse new-forest) keep?) (let ((node (car forest))) (if keep? (cond ((beg-pred node) => (lambda (repl-branches) (loop (cdr forest) #f (append (reverse repl-branches) new-forest)))) ((not (pair? node)) (loop (cdr forest) keep? (cons node new-forest))) (else (let-values* ((node? (symbol? (car node))) ((new-kids keep?) (loop (if node? (cdr node) node) #t '()))) (loop (cdr forest) keep? (cons (if node? (cons (car node) new-kids) new-kids) new-forest))))) (cond ((end-pred node) => (lambda (repl-branches) (loop (append repl-branches (cdr forest)) #t new-forest))) ((not (pair? node)) (loop (cdr forest) keep? new-forest)) (else (let-values* ((node? (symbol? (car node))) ((new-kids keep?) (loop (if node? (cdr node) node) #f '()))) (loop (cdr forest) keep? (if (or keep? (pair? new-kids)) (cons (if node? (cons (car node) new-kids) new-kids) new-forest) new-forest))))))))) (let-values* (((new-forest keep?) (loop forest #t '()))) new-forest))


(provide "sxml/tree-trans")

;; Local variables:
;; mode: scheme
;; end:
